#include <QCoreApplication>
#include <QObject>
#include "a.h"
#include "b.h"

int main(int argc, char *argv[])
{
    QCoreApplication app(argc, argv);

    Interface *a = new A;
    Interface *b = new B;

    //Compiles and works, but requires Qt4-style connect syntax
    QObject::connect(a->asQObject(), SIGNAL(someSignal()), b->asQObject(), SLOT(someSlot()));

    //Compiles and works, but no longer using an interface
    //QObject::connect(static_cast<A*>(a), &A::someSignal, static_cast<B*>(b), &B::someSlot);

    //Does not compile
    //QObject::connect(a->asQObject(), &Interface::someSignal, b->asQObject(), &Interface::someSlot);

    //Compiles but does not work. The connect fails with: "QObject::connect: signal not found in A"
    //QObject::connect(a->asQObject(), reinterpret_cast<void (QObject::*)()>(&Interface::someSignal), b->asQObject(), reinterpret_cast<void (QObject::*)()>(&Interface::someSlot));

    //Compiles but does not work. Segfaults
    //QObject::connect(reinterpret_cast<QObject*>(a), reinterpret_cast<void (QObject::*)()>(&Interface::someSignal), reinterpret_cast<QObject*>(b), reinterpret_cast<void (QObject::*)()>(&Interface::someSlot));

    a->tst_emitSomeSignal();

    int ret = app.exec();
    delete a;
    delete b;
    return ret;
}
